/* rsa1d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c_n1 = -1;

/* Subroutine */ int rsa1d_c(doublereal *array, integer *n, doublereal *resp,
        integer *m, doublecomplex *ans, doublecomplex *fft, integer *ireg, 
        integer *iflag)
{
    /* Initialized data */

    static doublereal zero = 0.;

    /* System generated locals */
    integer i__1, i__2, i__3, i__4;
    doublereal d__1, d__2;
    doublecomplex z__1;

    /* Builtin functions */
    double z_abs(doublecomplex *);
    void z_div(doublecomplex *, doublecomplex *, doublecomplex *);

    /* Local variables */
    extern /* Subroutine */ int fta2d_c(doublereal *, doublereal *,
            doublecomplex *, doublecomplex *, integer *),
            fta3d_c(doublecomplex *, integer *, integer *);
    static integer i__, m1, m3, n2, n21, m1i, n1i, nm1;

    /* Parameter adjustments */
    --fft;
    --ans;
    --resp;
    --array;

    /* Function Body */
    *iflag = 0;
    m1 = (*m - 1) / 2;
    i__1 = m1;
    for (i__ = 1; i__ <= i__1; ++i__) {
        n1i = *n + 1 - i__;
        m1i = *m + 1 - i__;
        resp[n1i] = resp[m1i];
/* L10: */
    }
    m3 = (*m + 3) / 2;
    nm1 = *n - (*m - 1) / 2;
    i__1 = nm1;
    for (i__ = m3; i__ <= i__1; ++i__) {
        resp[i__] = zero;
/* L20: */
    }
    fta2d_c(&array[1], &resp[1], &fft[1], &ans[1], n);
    n2 = *n / 2;
    n21 = n2 + 1;
    i__1 = n21;
    for (i__ = 1; i__ <= i__1; ++i__) {
        if (*ireg == 1) {
            goto L40;
        }
        if (z_abs(&ans[i__]) != zero) {
            goto L30;
        }
        *iflag = i__;
        goto L60;
L30:
        i__2 = i__;
        z_div(&z__1, &fft[i__], &ans[i__]);
        ans[i__2].r = z__1.r, ans[i__2].i = z__1.i;
        goto L50;
L40:
        i__2 = i__;
        i__3 = i__;
        i__4 = i__;
        z__1.r = fft[i__3].r * ans[i__4].r - fft[i__3].i * ans[i__4].i, 
                z__1.i = fft[i__3].r * ans[i__4].i +
                fft[i__3].i * ans[i__4].r;
        ans[i__2].r = z__1.r, ans[i__2].i = z__1.i;
L50:
        ;
    }
    d__1 = ans[1].r;
    i__1 = n2 + 1;
    d__2 = ans[i__1].r;
    z__1.r = d__1, z__1.i = d__2;
    ans[1].r = z__1.r, ans[1].i = z__1.i;
    fta3d_c(&ans[1], &n2, &c_n1);
L60:
    return 0;
} /* rsa1d_c */
